var game;
// colors is actually the array of level pages
//var colors = ["0xac81bd","0xff5050","0xdab5ff","0xb5ffda","0xfffdd0","0xcc0000","0x54748b","0x4b0082","0x80ab2f","0xff784e","0xe500db","0x223c4a","0x223c4a","0xf1290e","0x648080","0xbbc1c4","0x6f98a2","0x71717e"];
var levPages = 5;
// columns of thumbnails in each page
var columns = 1;
// rows of thumbnails in each page
var rows = 1;
// thumbnail width, in pixels
var thumbWidth = 60;
// thumbnail height, in pizels
var thumbHeight = 60;
// empty space between two thumbnails, in pixels
var spacing = 20;


window.onload = function() {	
	game = new Phaser.Game(320, 480, Phaser.AUTO, "");
     game.state.add("PlayGame", playGame);
     game.state.start("PlayGame");
}

var playGame = function(game){};
playGame.prototype = {
     preload: function(){
          game.load.spritesheet("levelthumb", "worlds/all_wolrds.png",280,400);
          game.load.image("transp", "transp.png");
     },
     create: function(){  
	// showing the game in full screen
	game.scale.pageAlignHorizontally = true;
	game.scale.pageAlignVertically = true;
	game.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
	//game.scale.setScreenSize(true);
          game.stage.backgroundColor = "#f57900"; 
          //this.pageText = game.add.text(game.width / 2, 16, "Swipe to select level page (1 / " + colors.length + ")", {font: "18px Arial", fill: "#ffffff"})
          this.pageText = game.add.text(game.width / 2, 16, "Swipe to select level page (1 / " + levPages + ")", {font: "18px Arial", fill: "#ffffff"})
          this.pageText.anchor.set(0.5);
          //this.scrollingMap = game.add.tileSprite(0, 0, colors.length * game.width, game.height, "transp");
          this.scrollingMap = game.add.tileSprite(0, 0, levPages * game.width, game.height, "transp");
          this.scrollingMap.inputEnabled = true;
          this.scrollingMap.input.enableDrag(false);
          this.scrollingMap.input.allowVerticalDrag = false;
          this.scrollingMap.input.boundsRect = new Phaser.Rectangle(game.width - this.scrollingMap.width, game.height - this.scrollingMap.height, this.scrollingMap.width * 2 - game.width, this.scrollingMap.height * 2 - game.height);
          this.currentPage = 0;
          var rowLength = thumbWidth * columns + spacing * (columns - 1);
          //var leftMargin = (game.width - rowLength) / 2;
	  var leftMargin = 20;
          var colHeight = thumbHeight * rows + spacing * (rows - 1);
          console.log(colHeight);
          //var topMargin = (game.height - colHeight) / 2;
	  var topMargin = 50;
          //for(var k = 0; k < colors.length; k++){
          for(var k = 0; k < levPages; k++){
               for(var i = 0; i < columns; i++){
                    for(var j = 0; j < rows; j++){
                         //var thumb = game.add.image(k * game.width + leftMargin + i * (thumbWidth + spacing), topMargin + j * (thumbHeight + spacing), "levelthumb");
			 var thumb = game.add.image(k * game.width + leftMargin, topMargin , "levelthumb");
                         //thumb.tint = colors[k];
			 thumb.frame=k;
                         thumb.levelNumber = k * (rows * columns) + j * columns + i;
                         //var levelText = game.add.text(60, 200, 'WORLD '+thumb.levelNumber, {font: "36px Arial", fill: "#000000"})
			 var styleName = {font: '45px Arial', fill: '#eeeeec', align: 'left', fontWeight: 'bold', stroke: '#8f5902', strokeThickness: 9};
			 var styleName0 = {font: '45px Arial', fill: '#e9b96e', align: 'center', fontWeight: 'bold', stroke: '#2e3436', strokeThickness: 9};
			 var styleName1 = {font: '45px Arial', fill: '#eeeeec', align: 'center', fontWeight: 'bold', stroke: '#204a87', strokeThickness: 9};
			 var styleName2 = {font: '45px Arial', fill: '#eeeeec', align: 'center', fontWeight: 'bold', stroke: '#8f5902', strokeThickness: 9};
			 var styleName3 = {font: '40px Arial', fill: '#cc0000', align: 'center', fontWeight: 'bold', stroke: '#2e3436', strokeThickness: 9};
			 var styleNameHome = {font: '45px Arial', fill: '#75507b', align: 'center', fontWeight: 'bold', stroke: '#000000', strokeThickness: 9};
                         //if(thumb.levelNumber<=3) var levelText = game.add.text(30, 180, 'WORLD '+thumb.levelNumber, styleName+''+thumb.levelNumber);
                         /*if(thumb.levelNumber==0) var levelText = game.add.text(30, 180, 'WORLD '+thumb.levelNumber, styleName0);
                         if(thumb.levelNumber==1) var levelText = game.add.text(30, 180, 'WORLD '+thumb.levelNumber, styleName1);
                         if(thumb.levelNumber==2) var levelText = game.add.text(30, 180, 'WORLD '+thumb.levelNumber, styleName2);
                         if(thumb.levelNumber==3) var levelText = game.add.text(30, 180, 'WORLD '+thumb.levelNumber, styleName3);*/
			 if(thumb.levelNumber==0) var levelText = game.add.text(50, 100, 'PRETTY\rWORLD', styleName0);
                         if(thumb.levelNumber==1) var levelText = game.add.text(50, 100, 'WOOD\rWORLD', styleName1);
                         if(thumb.levelNumber==2) var levelText = game.add.text(50, 100, 'SPACE\rWORLD', styleName2);
                         if(thumb.levelNumber==3) var levelText = game.add.text(50, 100, 'HORROR\rWORLD', styleName3);
			 if(thumb.levelNumber==4) var levelText = game.add.text(50, 100, 'GO\n HOME', styleNameHome);
                         thumb.addChild(levelText);
                         this.scrollingMap.addChild(thumb);
                    }
               }
          }
          this.scrollingMap.events.onDragStart.add(function(){
               this.scrollingMap.startPosition = this.scrollingMap.x;
          }, this);
          this.scrollingMap.events.onDragStop.add(function(event, pointer){
               if(this.scrollingMap.startPosition == this.scrollingMap.x){
                    for(i = 0; i < this.scrollingMap.children.length; i++){
                         var bounds = this.scrollingMap.children[i].getBounds();     
                         if(bounds.contains(pointer.x, pointer.y)){
                              //alert("Play level " + this.scrollingMap.children[i].levelNumber);
                              //break; 
				var loadLevel=Math.abs(this.scrollingMap.children[i].levelNumber+1);
				/*if(this.scrollingMap.children[i].levelNumber==0) window.open('levels_world1.html','_self');
				else{
					alert("Play level " + this.scrollingMap.children[i].levelNumber);
					break;
				}*/
				if(loadLevel<=4) window.open('levels_world'+loadLevel+'.html','_self');
				else window.open('index.html','_self');
                         }                  
                    }
               }
               else{
                    if(this.scrollingMap.startPosition - this.scrollingMap.x > game.width / 8){
                         this.changePage(1);
                    }
                    else{
                         if(this.scrollingMap.startPosition - this.scrollingMap.x < - game.width / 8){
                              this.changePage(-1);
                         }
                         else{
                              this.changePage(0);
                         }
                    }
               }
          }, this);
     },
     changePage: function(page){
          this.currentPage += page;
          this.pageText.text = "Swipe to select level page (" + (this.currentPage + 1).toString() + " / " + colors.length + ")"; 
          var tween = game.add.tween(this.scrollingMap).to({
               x: this.currentPage * -game.width    
          }, 300, Phaser.Easing.Cubic.Out, true);
     }
}
